//-----------------------------------------------------------
//Got to Have Something In here
//GBxScoreBoard
//-----------------------------------------------------------
class GBxScoreBoard extends JCScoreBoard;

struct GBxSBEntry
{
	var		int		ID;
	var     int     DeathPawnKills;
	var     int     GBxSpree;
};

var GBxSBEntry GBxSBTable[16];
//=============================================================================
function DrawKills(canvas Canvas, int I, float XOffset, int LoopCount)
{
	local int step;

	if (Canvas.ClipX >= 640)
		step = 16;
	else
		step = 8;

	Canvas.SetPos(Canvas.ClipX/2, (Canvas.ClipY*3)/8 + (LoopCount * step));

	if(SBTable[I].EnemyKillCount >= 100.0)
		Canvas.CurX -= 6.0;
	if(SBTable[I].EnemyKillCount >= 10.0)
		Canvas.CurX -= 6.0;
	if(GBxSBTable[I].DeathPawnKills >= 10.0)
		Canvas.CurX -= 18.0;
	if(GBxSBTable[I].DeathPawnKills >= 100.0)
		Canvas.CurX -= 6.0;

	Canvas.DrawText(SBTable[I].EnemyKillCount@"("$GBxSBTAble[I].DeathPawnKills$")", false);
} // DrawKills()

//=============================================================================
// Kill:Death ratio
function DrawSpree(canvas Canvas, int I, float XOffset, int LoopCount)
{
	local int step;

	if (Canvas.ClipX >= 640)
		step = 16;
	else
		step = 8;
	Canvas.SetPos((Canvas.ClipX*11)/16, (Canvas.ClipY*3)/8 + (LoopCount * Step));

	if(GBxSBTable[I].GBxSpree >= 10.0)
		Canvas.CurX -= 18.0;
	if(GBxSBTable[I].GBxSpree >= 100.0)
		Canvas.CurX -= 6.0;

	Canvas.DrawText(SBTable[I].Spree@"("$GBxSBTable[I].GBxSpree$")", false);
} // DrawSpree()

function Swap(int L, int R)
{
	local GBxSBEntry tmpEntry;

	super.Swap(L,R);

	tmpEntry = GBxSBTable[L];
	GBxSBTable[L] = GBxSBTable[R];
	GBxSBTable[R] = tmpEntry;
	// swap two elements of these logical structures, for sorting
	// Ya! Do not Forget my GBxSBTable in sorting
} // Swap()

function ShowScores(canvas Canvas)
{
	local PlayerReplicationInfo PRI;
	local PlayerPawn P;
	local int PlayerCount, LoopCount, i;
	local float XL, YL;

	Canvas.Font = RegFont;

	if(PlayerPawn(Owner).myHud != none && UnrealHUD(PlayerPawn(Owner).myHUD) != none)
	{
			UnrealHUD(PlayerPawn(Owner).myHUD).MOTDFadeOutTime = 128;
			UnrealHUD(PlayerPawn(Owner).myHUD).DrawMOTD(Canvas);
	}

	DrawHeader(Canvas);
	DrawTrailer(Canvas);

	// Wipe Everything
	for(i=0; i<ArrayCount(SBTable); i++)
	{
		SBTable[I].ID = 0;
		SBTable[I].bSpectator = false;
		SBTable[I].bIsAdmin = false;
		SBTable[I].EnemyKillCount = 0;
		SBTable[I].FriendKillCount = 0;
		SBTable[I].DeathCount = 0;
		SBTable[I].SuicideCount = 0;
		SBTable[I].Spree = 0;
		SBTable[I].Score = -500;
		GBxSBTable[I].DeathPawnKills= 0;
		GBxSBTable[I].GBxSpree= 0;
	}

	foreach AllActors (class'PlayerReplicationInfo', PRI)
	{
		SBTable[PlayerCount].Ping = PRI.Ping;
		SBTable[PlayerCount].PlayerName = PRI.PlayerName;
		SBTable[PlayerCount].Score = PRI.Score;
		if(JCPRI(PRI) != none) // in case of bots w/o JCPRI
		{
			SBTable[PlayerCount].ID = JCPRI(PRI).PlayerID;
			SBTable[PlayerCount].bSpectator = PRI.bIsSpectator;
//			if(JCPRI(PRI).bAdmin && JCGRI(PlayerPawn(Owner).GameReplicationInfo).bShowAdmins)
//				SBTable[PlayerCount].PlayerName = SBTable[PlayerCount].PlayerName @ "(admin)";
			if(JCGRI(PlayerPawn(Owner).GameReplicationInfo).bShowAdmins)
				SBTable[PlayerCount].bIsAdmin = JCPRI(PRI).bAdmin;
			SBTable[PlayerCount].EnemyKillCount = JCPRI(PRI).EnemyKillCount;
			SBTable[PlayerCount].FriendKillCount = JCPRI(PRI).FriendKillCount;
			SBTable[PlayerCount].DeathCount = JCPRI(PRI).DeathCount;
			SBTable[PlayerCount].SuicideCount = JCPRI(PRI).SuicideCount;
			SBTable[PlayerCount].Spree = JCPRI(PRI).jSpree;
            // me add my SBTable
            if(GBxPRI(PRI) != none) // Just in cause
            {
                GBxSBTable[PlayerCount].DeathPawnKills = GBxPRI(PRI).DeathEnemyKillCount;
                GBxSBTable[PlayerCount].GBxSpree = GBxPRI(PRI).GBxSpree;
            }
            else
                log("Error! NO GBxPRI for Score add-on",'GBxCoop');
		}
		PlayerCount++;
		if(PlayerCount >= ArrayCount(SBTable)) break;
	}

	SortScores(PlayerCount);
	LoopCount = 0;
	for(i=0; i<PlayerCount; i++)
	{
		Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 255;
		DrawPing(Canvas, i, 0, LoopCount);

/*		set colors for display, this is priority order (low->high):
		default: green
		spectator: white
		admin: yellow
*/
		// default:green
		Canvas.DrawColor.R = 0;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 0;

		if(SBTable[I].bSpectator) // white
		{
			Canvas.DrawColor.R = 255;
			Canvas.DrawColor.G = 255;
			Canvas.DrawColor.B = 255;
		}
		if(SBTable[I].bIsAdmin) // yellow
		{
			Canvas.DrawColor.R = 255;
			Canvas.DrawColor.G = 255;
			Canvas.DrawColor.B = 0;
		}

		DrawID(Canvas, i, 0, LoopCount);
		DrawName(Canvas, i, 0, LoopCount);
		if(!SBTable[I].bSpectator)
		{
			DrawKills(Canvas, i, 0, LoopCount);
			DrawDeaths(Canvas, i, 0, LoopCount);
			DrawSpree(Canvas, i, 0, LoopCount);
			DrawScores(Canvas, i, 0, LoopCount);
		}
		LoopCount++;
	}

	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;

	// makes the MOTD show with the scoreboard
	if(PlayerPawn(Owner).myHud != none && UnrealHUD(PlayerPawn(Owner).myHUD) != none)
		UnrealHUD(PlayerPawn(Owner).myHUD).MOTDFadeOutTime = 0;
} // ShowScore()

defaultproperties
{
}
